static const char *RcsId = "$Header: /cvsroot/tango-cs/tango/cppserver/TangoTest/main.cpp,v 1.2 2005/08/02 09:58:38 nleclercq Exp $";
//+=============================================================================
//
// file :        main.cpp
//
// description : C++ source for a TANGO device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//               The main should be the same for every Tango device server.
//
// project :     TANGO Device Server  
//
// $Author: nleclercq $ 
// 
// $Revision: 1.2 $
//
// $Log: main.cpp,v $
// Revision 1.2  2005/08/02 09:58:38  nleclercq
// Minor change to avoid compiler warning
//
// Revision 1.1.1.1  2004/05/07 12:43:45  taurel
// Initial import
//
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043 
//               FRANCE       
//   
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
 
#include <tango.h>        
   
int main(int argc,char *argv[])         
{ 
  
	Tango::Util *tg = 0;     
	try    
  	{ 
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);   

		// Create the device server singleton  
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);   

		// Run the endless loop
		//----------------------------------------
    		cout << "Ready to accept request" << endl; 
		tg->server_run();    
	}
	catch (bad_alloc)  
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)   
	{
		Tango::Except::print_exception(e);
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl; 
	}
	tg->server_cleanup();
	return(0);
}
  


